abstract type AbstractProject end

function read_parameters end
function setup_project end
function setup_initialdata! end
function setup_analysis! end
function evolve! end
function output end

function run(args...)
  prms = read_parameters(args)
  prjct = setup_project(prms)
  setup_initialdata!(prjct)
  setup_analysis!(prjct)
  evolve!(prjct)
  output(prjct)
end
