using DrWatson
@quickactivate "dg1d"

prms = AdvectionEq.Parameters(
      N = 5, K = 20, CFL = 0.1, quadr = :LGL, scheme = :RK4,
      advection_v = 1.0, type_bdryconditions = :periodic, type_initialdata = :sine,
      tstart = 0.0, tend = 1.0, xmin = 0.0, xmax = 1.0,
      av_method = :MDA, av_cmax = 1.0)

AdvectionEq.evolve(prms)
