export SREulerEq
module SREulerEq


using dg1d
import dg1d: Abstract_SystemOfEqs, Abstract_BdryConditions, flux, maxabs_v, 
             AV.Abstract_AV, Mesh, EoS
import Parameters: @with_kw, @unpack


include("eq.jl")
# include("variables.jl")
include("rhs.jl")
include("initialdata.jl")
include("bdryconditions.jl")


# @with_kw struct Parameters <: dg1d.Abstract_Parameters
#   mesh::dg1d.Mesh_Parameters
#   evolution::dg1d.Evolution_Parameters
#   problem::dg1d.Problem_Parameters
#   av::dg1d.AV.AV_Parameters
#   eq::EulerEq_Parameters
# end


include("evolve.jl")
include("plot.jl")


end # module
