# Observations

# TODO

- [ ] Moved eqs.jl from base package to here and define AdvectionEq
  and BurgersEq, etc. as subtypes of Abstract_ScalarEq.
  We do so because the Abstract_ScalarEq interface has no meaning elsewhere.

## Heat equation

- Stability depends on combination of nodal point set and time stepping scheme.
  For a configuration with
  ```julia
    N = 5
    K = 80
    CFL = 0.25
    type_bdryconditions = :periodic
    type_initialdata = :sine
    tstart = 0.0
    tend = 4.3 # 30.3
    xmin = 0.0
    xmax = 2.0 * π
  ```
  the following was observed
  | `scheme`/`quadr`  | `:LGL_lumped`  | `:LGL`    | `:GLGL`   |
  |:------------------|----------------|-----------|-----------|
  | `:SSPRK3`         | stable         | unstable  | unstable  |
  | `:LSEKR4`         | stable         | stable    | stable    |
  | `:RK4`            | stable         | stable    | unstable  |
  | `:RK4_twothirds`  | stable         | stable    | unstable  |
  | `:RK4_Ralston`    | stable         | stable    | unstable  |

  Reason for this is unclear ...
