@testset "High resolution shock capturing" begin


@testset "Shock sensing" begin

  indicator = randn(Float64, 10)
  m = 0.1
  M = 1.5
  k = 0.1
  ramp_fn(s) = dg1d.ShockSensor.linear_ramp_function(s, k)

  s = dg1d.ShockSensor.shock_sensor(ramp_fn, indicator, m, M)

  inbounds_logic = @.( (s >= 0.0) & (s <= 1.0) )
  @test all(inbounds_logic) == true

end


end
